<?php
class AttendanceConfController extends AppController
{   
	var $helpers = array('Html','Xml');
	var $uses=array('Poll','Group', 'Host','Configure', 'Validation','License','User',
		'Workstatus','Grpattendconf','Hstattendance');
	var $components = array("GenerateFiles");
	var $layout='attendance';
		
	function beforeFilter()
	{

	}
	
	function index($errorMessage = null)
	{
		$this->set("manage", $this->requestAction("/attendance_conf/manage", array("return"))) ;
    	$this->layout = "system";
    	$this->pageTitle = __('title',$return = true);  
	}
	
	function manage($depand=null,$tag=null){
        $errorMessage=array();
        $this->layout='ajax';
        $data= array();
		
        if($depand=='2'){//項目名変更
			var_dump($this->data);
			foreach($this->data['Workstatus'] as $s){
				
				echo $s;
			}
			$newname = eregi_replace("　", " ", $this->data['Workstatus']['content_'.$tag]);
            $newname = trim($newname, " ");
            if($this->Validation->maxLength($newname,200)){
                $updateaddition=Array(
                'Workstatus' => Array(
                'id' => $tag,
                'name' => $newname,
                )
                );
                $this->Workstatus->save($updateaddition);
				$this->Hstattendance->updateAll( array("1=1"), array('Hstattendance.newconf' => 1));

            }
            else{
                $errorMessage=array();
                if(!$this->Validation->maxLength($this->data['Workstatus']['content_'.$tag],200)){
                    if(@ !in_array('E-00300',$errorMessage['computer_list']))
                    $errorMessage['computer_list'][] = 'E-00300';
                }
            }
			$data= $this->Workstatus->findAll();
			
        }
		else if($depand=='4'){
            if($this->data['Grpattendconf']['notification']!="" 
				&& $this->Validation->numeric($this->data['Grpattendconf']['notification'])
				&& $this->data['Grpattendconf']['threshold']!="" 
				&& $this->Validation->numeric($this->data['Grpattendconf']['threshold']) )
			{
                $set_update=Array(
                'Grpattendconf' => Array(
                'id' => 1,
				'group_id' => 1,
                'notification' => $this->data['Grpattendconf']['notification'],
				'threshold' => $this->data['Grpattendconf']['threshold'],
                )
                );
                $this->Grpattendconf->save($set_update);
            }
            else{
                $errorMessage=array();
                if($this->data['Grpattendconf']['notification']=="" || $this->data['Grpattendconf']['threshold']==""){
                    if(@ !in_array('E-00100',$errorMessage['alert_depand']))
                    $errorMessage['alert_depand'][] = 'E-00100';
                }
                else if(!$this->Validation->numeric($this->data['Grpattendconf']['notification']) || !$this->Validation->numeric($this->data['Grpattendconf']['threshold'])){
                    if(@ !in_array('E-00600',$errorMessage['alert_depand']))
                    $errorMessage['alert_depand'][] = 'E-00600';
                }
            }
        }else
			$data= $this->Workstatus->findAll();


//var_dump($data);
        //$data= $this->Workstatus->findAll();
		$set= $this->Grpattendconf->find("Grpattendconf.id=1");//var_dump($set);
        $this->set('set', $set);
        $this->set('data', $data);
        $this->set('errorMessage', $errorMessage);
    }
	
	function status($hostid = null, $status = null, $hostname = null)
    {	
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			$hostid = $host['Host']['id'];
		}
		
		if(is_null($hostid) || is_null($status))
			echo "0";
		elseif(!$this->Validation->numeric($hostid) || !$this->Validation->numeric($status) ){
			echo "0";
		}
		else{
			$data = $this->Hstattendance->find(
				array("Hstattendance.host_id" => $this->Lv->spec_char_dbm($hostid),
						"Hstattendance.status" => $this->Lv->spec_char_dbm($status)));
			
			$set_update=Array(
                'Hstattendance' => Array(
                'host_id' => $hostid,
				'status' => $status,
                )
                );
			if(empty($data))
				$set_update['Hstattendance']['lasttime'] = "'".date("Y/m/d H:i:s")."'";
            $this->Hstattendance->save($set_update);
			echo "1";
		}
	}
	
	function check($hostid = null, $hostname = null)
    {	
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			$hostid = $host['Host']['id'];
		}
		
		if(is_null($hostid))
			echo "0";
		else{
			$data = $this->Hstattendance->find(array("Hstattendance.host_id" => $this->Lv->spec_char_dbm($hostid)), "newconf");
			//var_dump($data);
			if(empty($data))
				echo "1";
			else
				echo $data['Hstattendance']['newconf'];
		}
	}
	
    function get($hostid = null, $hostname = null)
    {	
		$this->layout="ajax";
		if($hostid == 0 && !is_null($hostname))
		{
			$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($hostname));
			$hostid = $host['Host']['id'];
		}
		
		$criteria = array();
		$criteria[] = "1=1";
		$fields = array(
			'Workstatus.id',
			'Workstatus.autoreset',
			'Workstatus.name');

		$data = $this->Workstatus->findAll($criteria, $fields, "id");
		
		$set= $this->Grpattendconf->findAll("Grpattendconf.id=1", array("Grpattendconf.threshold","Grpattendconf.cycle"));
		
		$this->Hstattendance->updateAll( array("Hstattendance.host_id = $hostid"), array('Hstattendance.newconf' => 0));

		
		header("Content-Type: application/xml; charset=utf-8");
		$this->set(compact('data'));
		$this->set(compact('set'));
    }
}
?>